Home / Open MBOX File Online
Local-first MBOX viewer

Open an MBOX file — no mail client needed

Drop an .mbox file — a Google Takeout export, a Thunderbird archive, an old Unix mailbox — and read and search it on this page. Parsed locally in your browser; it never leaves your device.

Drop your archive here
or click to choose · parsed locally in this tab
MBOXZIP · Pro
Ready — 0 bytes uploadedFile API · Web Worker

No archive at hand? — 12 messages, 5 attachments, all invented. What is in it

Direct answer

How do I open a Google Takeout MBOX file without importing it into a mail app?

Open the .mbox file with a viewer that reads the archive directly, without importing it into a mail client. Mailward scans the file in 4 MB chunks, keeps a message index in memory, and reads a message's byte range when you open it. Your mail stays on your device. Google Takeout stores Gmail labels in each message's X-Gmail-Labels header; Mailward rebuilds them as browsable folders, including messages with multiple labels. Listing and search cover the full mailbox; reading messages within the first 500 MB is free, while reading beyond that point requires Pro. The initial scan and full-body searches take longer on larger archives or slower devices.

STEP 01

Drop the .mbox file — it is read locally, nothing is uploaded.

STEP 02

Browse the message list and open any message with attachments.

STEP 03

Search the whole mailbox by subject, sender, or body text.

STEP 04

Export three messages a day free, or batch-export with a license.

Why it matters

Open an MBOX file — no mail client needed

Mailward opens an MBOX directly in your browser, including a Google Takeout export: drop the file, browse the messages, search the mailbox, and open attachments. The file is parsed locally in a Web Worker.

Listing and search cover the whole mailbox; reading messages in the first 500 MB and exporting three single messages a day are free. Reading beyond that point and batch export require Pro.

The format itself

What Google Takeout actually hands you

Ask Google for your Gmail and you get MBOX: one plain-text file with every message concatenated, each introduced by a line starting with "From ". There is no folder tree inside it, because Gmail does not have folders. Labels survive as an X-Gmail-Labels header on each message, and threading survives as ordinary References and In-Reply-To headers. Mailward reads that label header and rebuilds your labels as browsable folders in the sidebar — a message carrying three labels appears under all three — so the structure Gmail's interface implied comes back, instead of one flat wall of messages.

The practical problem is size. A decade of mail is routinely several gigabytes in a single file, and the standard advice — install Thunderbird, create a profile, add ImportExportTools NG, import, wait — is a lot of ceremony when the actual goal is to find one message from 2019.

Mailward reads the MBOX directly in the browser without loading it whole. That matters more than it sounds: a browser tab cannot hold a string longer than about 512 MB, so any viewer that decodes the file as one piece of text fails outright on a large Takeout — that was the previous version of this page's reader. The current reader scans the file once in 4 MB chunks, records each message's byte range, and re-reads just that range when you open a message. Subject and sender search use the index and answer immediately; body search re-reads messages as it goes, so on a very large mailbox it takes longer and reports progress as it scans. The free tier reads the first 500 MB — what the old whole-file reader could ever open — and the whole mailbox is listed and searchable; reading past that mark is the Pro part.

What Takeout delivers
One .mbox file, no folder hierarchy
Where labels go
X-Gmail-Labels header — rebuilt here as browsable label folders
Threading
Preserved via References / In-Reply-To headers
Needs Thunderbird?
No — nothing to install or configure
Published desktop test
A 1.6 GB synthetic mailbox with 40,936 messages opened in 29.6 seconds on an Apple M3 Mac in Chrome 153 (single run, 21 September 2026)
Separator rule
A line splits messages only with the full From_ shape — sender plus a seconds-precision date (asctime, Takeout's offset-before-year variant, or RFC 1123); "From " alone in a body line never splits a message, and ">From " escapes are undone on display
Label folders
Built from X-Gmail-Labels with RFC 2047-encoded names decoded and listed alphabetically; a mailbox with more than 100 distinct labels keeps the 100 most-populated as folders, and every message stays in the all-messages list
Known limit
Opening and body search scan the file; speed depends on the device, storage and message contents. The index stays in memory, not every message body.

Comparing formats? PST, OST, OLM, MBOX & EML explained — what each one is internally, and what is lost converting between them.

Questions

Before you trust a mail file to a website

Q. Can it open a Google Takeout Gmail export?

Yes — Takeout's .mbox output is the main thing people open here, including multi-gigabyte exports. The file is scanned once in 4 MB chunks to index where each message starts; only that index and the listing (subject, sender, date, labels) stay in memory, and a message is parsed when you open it. Expect the first pass to take on the order of a minute per gigabyte, with a progress percentage while it runs. The free tier reads messages in the first 500 MB of the file; everything is listed and searchable, and reading past that mark is part of the one-time Pro license. Pro also opens the Takeout .zip itself: the Mail/*.mbox files inside are read without extracting the download first (up to 1 GB unpacked; larger exports are extracted and the .mbox opened directly).

Q. My Takeout download is a ZIP that says it is invalid or won't open. What now?

Often it is not damaged but unfinished: a ZIP keeps its list of contents at the very end of the file, so a download that stopped early is invalid to every tool. Test it before extracting — unzip -t, or python3 -m zipfile -t on any system with Python — and download that archive again if the test fails. Watch out for tar on a Mac: on a ZIP cut in half it wrote the mailbox at its full size with the missing half as zero bytes, and exited with an error that is easy to miss. What each tool does with a cut Takeout ZIP, and how split exports and .tgz downloads differ, is measured in a separate write-up.

Q. Do my Gmail labels survive?

Yes. Takeout writes each message's labels into an X-Gmail-Labels header, and Mailward rebuilds them as folders in the sidebar — a message with three labels appears under all three. Unlabeled mail stays in the flat all-messages list, and with Pro you can batch-export a single label as MBOX or EML.

Q. Do I need Thunderbird or any mail client?

No. The MBOX is parsed directly in your browser — nothing to install, no profile or import wizard to configure.

Q. Why do some viewers split a message in the middle — and does Mailward?

Because the only thing that marks a new message in an MBOX is a line beginning "From ", and a plain-text body can contain one of those too ("From what I remember, …"). Importers that split on the five-character prefix alone — Python's standard mailbox module among them — cut such a message in two, and mboxo-style files, which never escape those lines, make it happen in the wild. Mailward treats a line as a separator only when it has the whole From_ shape: a sender token followed by a date with seconds, in the asctime form ("Thu Jan 1 00:00:00 1970"), Google Takeout's variant with a UTC offset before the year, or the RFC 1123 form some tools write. A body line that merely starts with "From " stays inside its message, and mboxrd escapes (">From ") are undone when a message is shown, so you read what was written. A separator cut in half by one of the 4 MB scan chunks is still found: the scan carries the unfinished last line into the next chunk.

Q. My .mbox opens as a single message, or not at all — why?

Mailward decides how to read the file from its first bytes, not its name. A file that begins with a From_ line is a mailbox and is split at every separator; one that does not — a single saved message renamed .mbox, say — is read as one RFC 5322 message rather than refused, a UTF-8 byte-order mark ahead of the first line is skipped as not part of the mailbox, and Windows-style CRLF line endings read the same as LF. Two things do stop an open: a file with no message text at all, and one whose every message fails to parse — each is refused with a message saying so, while a single unparseable message in an otherwise good mailbox is skipped, not fatal. A file that is not MBOX at all, such as a still-compressed Takeout .tgz or a PST, is named for what it is in the error.

Q. Is my mail uploaded to a server?

No. The file is read with the browser's File API and parsed in a Web Worker on your machine. You can go offline after the page loads and keep reading.

Q. Can I convert messages out of the MBOX?

Single-message EML export is free for three messages a day, attachments included. Batch export of folders or the whole mailbox is part of the one-time Pro license, as is reading messages past the first 500 MB of a large mailbox.

Q. Can I turn an MBOX file into an Excel spreadsheet?

Yes — as a list of the messages, not their text. With Pro, Mailward exports the whole mailbox, one label folder or a set of search results as a CSV index that Excel opens directly: one row per message with its date (ISO 8601, in UTC), sender name, sender address, subject and whether it has attachments. A whole-mailbox export adds a Folder column and lists each message once under the mailbox and again under every Gmail label it carries; a search-results export adds the archive, the folder and which field matched. Message bodies are not in the sheet — export those as MBOX or EML. The file begins with a UTF-8 byte-order mark, which is what Excel needs to show accented and non-Latin subjects correctly when you double-click a CSV, and a value that starts with =, +, - or @ is written with a leading apostrophe, so a subject crafted as a formula is shown as text instead of being run.

Free viewing, search, and 3 single-message exports a day. MBOX reading is free through the first 500 MB; listing and search cover the whole file. Batch conversion is a one-time $19 licence — no subscription, no recurring fees.

See what Pro addsGet Pro — $19